/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id: wamp_client.h 108 2015-06-11 09:15:46Z coas-nagasima $
 */

#ifndef WAMP_CLIENT_H
#define WAMP_CLIENT_H

typedef enum wamp_client_roles{
	WAMP_CLIENT_ROLES_PUBLISHER = 1,
	WAMP_CLIENT_ROLES_SUBSCRIBER = 2,
	WAMP_CLIENT_ROLES_CALLER = 4,
	WAMP_CLIENT_ROLES_CALLEE = 8,
	WAMP_CLIENT_ROLES_IN_GETTING = 0x80,
} wamp_client_roles_t;

typedef struct wamp_client
{
	struct wamp_state *s;
	int id;
	char realm[80];
	wamp_client_roles_t roles;
} wamp_client_t;

void wamp_client_welcome(wamp_client_t *client);
void wamp_client_welcome_client_id(wamp_client_t *client, const char *value);
void wamp_client_welcome_details(wamp_client_t *client, const char *value);
void wamp_client_welcome_details_param(wamp_client_t *client, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_client_welcome_close(struct wamp_state *s);

void wamp_client_abort(wamp_client_t *client);
void wamp_client_abort_details(wamp_client_t *client, const char *value);
void wamp_client_abort_details_param(wamp_client_t *client, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_client_abort_reason(wamp_client_t *client, const char *value);
void wamp_client_abort_close(struct wamp_state *s);

void wamp_client_challenge(wamp_client_t *client);
void wamp_client_challenge_authmethod(wamp_client_t *client, const char *value);
void wamp_client_challenge_extra(wamp_client_t *client, const char *value);
void wamp_client_challenge_extra_param(wamp_client_t *client, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_client_challenge_close(struct wamp_state *s);

void wamp_client_goodbye(wamp_client_t *client);
void wamp_client_goodbye_details_param(wamp_client_t *client, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_client_goodbye_details(wamp_client_t *client);
void wamp_client_goodbye_reason(wamp_client_t *client, const char *value);
void wamp_client_goodbye_close(struct wamp_state *s);

#endif // WAMP_CLIENT_H
