/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2003-2004 by Platform Development Center
 *                                          RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
 *  Copyright (C) 2013      by Mitsuhiro Matsuura
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *	RX630 UARTpVAI/OW[
 */
#include "kernel_impl.h"
#include <sil.h>
#include "target_serial.h"

/*
 *  SIOhCȍ
 */
void
sio_initialize(intptr_t exinf)
{
	rx630_uart_initialize();
}

/*
 *  VAI/O|[g̃I[v
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB  *p_siopcb = NULL;
	ER      ercd;
	INTNO	intno_sio_tx, intno_sio_rx;
	
	/*
	 *  VAI/O݂}XND
	 *  (dis_int֐́A"\kernel\interrupt.c"ɋLq)
	 */
	p_siopcb = rx630_uart_get_siopcb(siopid);
	intno_sio_tx = rx630_uart_intno_tx(p_siopcb);
	intno_sio_rx = rx630_uart_intno_rx(p_siopcb);
	ercd = dis_int(intno_sio_tx);
	assert(ercd == E_OK);
	ercd = dis_int(intno_sio_rx);
	assert(ercd == E_OK);
	
	p_siopcb = 
		rx630_uart_opn_por(siopid , exinf , UART_BAUDRATE , UART_CLKSRC);

	/*
	 *  VAI/O݂}XND
	 *  (ena_int֐́A"\kernel\interrupt.c"ɋLq)
	 */
	ercd = ena_int(intno_sio_tx);
	assert(ercd == E_OK);
	ercd = ena_int(intno_sio_rx);
	assert(ercd == E_OK);

	return(p_siopcb);
}

/*
 *  VAI/O|[g̃N[Y
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	ER        ercd;
	INTNO	intno_sio_tx, intno_sio_rx;

	/*
	 *  foCXˑ̃N[YD
	 */
	rx630_uart_cls_por(p_siopcb);
	
	/*
	 *  VAI/O݂}XND
	 */
	intno_sio_tx = rx630_uart_intno_tx(p_siopcb);
	intno_sio_rx = rx630_uart_intno_rx(p_siopcb);
	ercd = dis_int(intno_sio_tx);
	assert(ercd == E_OK);
	ercd = dis_int(intno_sio_rx);
	assert(ercd == E_OK);
}

/*
 *  SIO̊݃nh
 */
void sio_tx_isr(intptr_t exinf)
{
	rx630_uart_tx_isr(exinf);
}

/*
 *  SIO̊݃nh
 */
void sio_rx_isr(intptr_t exinf)
{
	rx630_uart_rx_isr(exinf);
}

/*
 *  VAI/O|[gւ̕M
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char c)
{
	return(rx630_uart_snd_chr(siopcb, c));
}

/*
 *  VAI/O|[g̕M
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	return(rx630_uart_rcv_chr(siopcb));
}

/*
 *  VAI/O|[g̃R[obN̋
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	rx630_uart_ena_cbr(siopcb, cbrtn);
}

/*
 *  VAI/O|[g̃R[obN̋֎~
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	rx630_uart_dis_cbr(siopcb, cbrtn);
}

/*
 *  VAI/O|[g̑M\R[obN
 */
void
rx630_uart_irdy_snd(intptr_t exinf)
{
	/* ʕisyssvc\serial.cjɂsio_irdy_snd֐Ăяo*/
	sio_irdy_snd(exinf);
}

/*
 *  VAI/O|[g̎MʒmR[obN
 */
void
rx630_uart_irdy_rcv(intptr_t exinf)
{
	/* ʕisyssvc\serial.cjɂsio_irdy_rcv֐Ăяo*/
	sio_irdy_rcv(exinf);
}

